<script>
    import { max } from "d3-array";
    import { scaleLinear } from "d3-scale";
  
    // Properties to export
    export let buildingType; 
    export let width; 
    export let i;
    export let data; 
    export let heating; 
    export let scaling;
  
    // Variables to draw lines/paths
    const centerY = 28 * i + 10;
    const startX = 5;
    const endX = width - 170;
    const numOfDataPoints = Object.keys(data).length;
  
    // Scales
    let perLineScale;
    let acrossAllLinesScale;
    $: perLineScale = scaleLinear()
      .domain([0, max(data, (d) => d.total_heating_energy)])
      .range([1, 10]);
  
    $: acrossAllLinesScale = scaleLinear()
      .domain([0, heating])
      .range([1, 20]);
  
    const xScale = scaleLinear()
      .domain([0, numOfDataPoints]) 
      .range([startX, endX]);
  
    // Create path for the line
    let path = "";
    $: {
      path = ""; // If the path isn't reset the change won't occur
      data.forEach((element, index) => {
        let thickness = 1;
        if (scaling == "across all") {
          thickness = acrossAllLinesScale(element.total_heating_energy);
        } else {
          thickness = perLineScale(element.total_heating_energy);
        }
        if (index == 0) {
          path += `M${xScale(index)} ${centerY - thickness} `;
        } else {
          path += `L${xScale(index)} ${centerY - thickness}`;
        }
      });
      data
        .slice()
        .reverse()
        .forEach((element, index) => {
          let thickness = 1;
          if (scaling == "across all") {
            thickness = acrossAllLinesScale(element.total_heating_energy);
          } else {
            thickness = perLineScale(element.total_heating_energy);
          }
          path += `L${xScale(numOfDataPoints - 1 - index)} ${
            centerY + thickness
          }`;
        });
      path += "Z"; 
    }
  </script>
  
  <svg>
    <path d={path} />
    <text x=540, y={centerY + 3} style="font-size:12">{buildingType}</text>
  </svg>
  